// Uebung 8 zum Fach Betriebssysteme, Child1-Programm
// Copyright Matthias Jauernig, 03IN
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdbool.h>

int i, sigi[4];
bool reset, ende;

void sigintfkt (int signr){
	printf(	"Child1 -> Aktuelle Signalzaehlerstaende:\n"
		"           SIGINT:  %d\n"
		"           SIGQUIT: %d\n"
		"           SIGUSR1: %d\n"
		"           SIGUSR2: %d\n",
		sigi[0],sigi[1],sigi[2],sigi[3]);
	printf("Child1 -> Alter Zaehlzyklusstand: %d\n",i);
	sigi[0]++;
}

void sigquitfkt(int signr){
	printf("Child1 -> Verlassen des Zaehlzyklus'...\n");
	printf("Child1 -> Alter Zaehlzyklusstand: %d\n",i);
	ende=true;
	sigi[1]++;
}

void sigusr1fkt(int signr){
	printf("Child1 -> Zaehlzyklus wird neu gestartet...\n");
	printf("Child1 -> Alter Zaehlzyklusstand: %d\n",i);
	reset=true;
	sigi[2]++;
}

void sigusr2fkt(int signr){
	printf("Child1 -> Aktueller Zaehlzyklusstand: %d\n",i);
	sigi[3]++;
}


int main(int argc, char** argv){
	int count;
	sigi[0]=0; sigi[1]=0; sigi[2]=0; sigi[3]=0;
	reset=false; ende=false; 
	
	if(argc>1){
		count=atoi(argv[1]);
		if(count==0){
			printf("Child1 -> Nicht-Zahl uebergeben...\n");
			exit(1);
		}
	}
	else{
		printf("Child1 -> Keine Zaehlzyklenzahl an Child1 uebergeben...\n");
		exit(1);
	}
	
	// unter Solaris
	sigset(SIGINT,  sigintfkt );
	sigset(SIGQUIT, sigquitfkt);
	sigset(SIGUSR1, sigusr1fkt);
	sigset(SIGUSR2, sigusr2fkt);

	if(kill(getppid(),SIGUSR1) < 0)
		perror("Child2  -> Signal senden an Parent");
	
	printf("Child1  -> Meine PID:  %d\n",(int)getpid());
	printf("Child1  -> Parent-PID: %d\n\n",(int)getppid());
	for(i=0; i<count; i++){
		if(reset==true){
			i=0;
			reset=false;
		}
		if(ende==true)
			break;
		//if(i%(count/10) == 0)
		//	printf("Child1  -> Zaehler: %d\n",i);
	}
	
	exit(0);
}
